;;;      (chamfer & fillet)
;;;  .
;;;        -     ,
;;;  -   .        ,
;;;       .
;;;    :
;;;Burlakov <shea@d3235.dd.vaz.tlt.ru>
;;;
;;;---------------------------------> 2003 <-----------------------------------------
;;;      CHAMFILL     .
;;;       , ,   .
;;;      ,   AutoCAD'.
;;;       .
;;;---------------------->   vkle@saminfo.ru <--------------------------

;;;********************************************************************
;;;                             RES_DO
;;;********************************************************************
(defun res_do ()
  (cond
    ((= spos "d")
     (set_tile "dist1" (rtos (setq dist1 chamfera)))
     (set_tile "dist2" (rtos (setq dist2 chamferb)))
    )
    ((= spos "a")
     (set_tile "leng" (rtos (setq leng chamferc)))
     (set_tile "angl" (angtos (setq angl chamferd)))
    )
    (t (set_tile "rad" (rtos (setq rad filletrad))))
  ) ;_  cond
) ;_  defun

;;;********************************************************************
;;;                              SPOS_DO
;;;********************************************************************
(defun spos_do ()
  (cond
    ((= spos "d") (setq d "1" a "0" f "0" cham 0))
    ((= spos "a") (setq d "0" a "1" f "0" cham 1))
    (t (setq d "0" a "0" f "1"))
  ) ;_  cond
  (foreach x '("d" "a" "f") (set_tile x (eval (read x))))
  (mapcar '(lambda (x y) (mode_tile x (- 1 (atoi y)))) '("dist1" "dist2" "leng" "angl" "rad") (list d d a a f))
) ;_  defun

;;;********************************************************************
;;;                             c:chamfill
;;;********************************************************************
(defun c:chamfill (/ vars     *error*  app      dcl_id   what     cham     trim     dist1    dist2
                     leng     angl     rad      spos     mode     tr       ntr      ini      par
                     dcl_xy   l        pl       tip      d        a        f        cmdecho  chammode
                     trimmode chamfera chamferb chamferc chamferd filletrad
                    ) ;_  /
  (setq vars '("cmdecho" "chammode" "trimmode" "chamfera" "chamferb" "chamferc" "chamferd" "filletrad"))
  (foreach x vars (set (read x) (getvar x))) ;  
  (defun *error* (a)
    (if dcl_id
     (unload_dialog dcl_id)
    )
    (vla-endundomark (vla-get-activedocument (vlax-get-acad-object))) ;   undo
    (vl-cmdf "_.undo" 1)                ;  
    (princ "\n")
    (princ)
  ) ;_ *error*
  (setq par '("dcl_xy" "mode" "tip" "spos" "cham" "trim" "dist1" "dist2" "leng" "angl" "rad"))
  (if (setq ini (vl-bb-ref 'chamfill_ini))
    (while par                          ;   ,   
      (set (read (car par)) (car ini))
      (setq ini (cdr ini) par (cdr par))
    ) ;_  while
    (setq cham   (getvar "chammode")    ;   -  
          trim   (getvar "trimmode")
          dist1  (getvar "chamfera")
          dist2  (getvar "chamferb")
          leng   (getvar "chamferc")
          angl   (getvar "chamferd")
          rad    (getvar "filletrad")
          dcl_xy '(-1 -1)               ;    
    ) ;_  setq
  ) ;_  if
  (cond
    ((< (setq dcl_id (load_dialog "chamfill.dcl")) 0)
      (princ "\n  chamfill.dcl  !")
      (exit)
    )
    (t
     ;;   
     (setq what 4)
     (cond
       ((= spos "d") (setq d "1" a "0" f "0" cham 0))
       ((= spos "a") (setq d "0" a "1" f "0" cham 1))
       (t (setq spos "f" d "0" a "0" f "1"))
     ) ;_  cond
     (cond
       ((= mode "tr") (setq tr "1" ntr "0" trim 1))
       (t (setq mode "ntr" tr "0" ntr "1" trim 0))
     ) ;_  cond
     (cond
       ((= tip "pl") (setq l "0" pl "1"))
       (t (setq tip "l" l "1" pl "0"))
     ) ;_  cond

     (while (> what 3) ;_ 3 -  , 4 -    
       (new_dialog "chamfill" dcl_id "" dcl_xy)
       ;;   
       (foreach x '("d" "a" "f" "tr" "ntr" "l" "pl") (set_tile x (eval (read x))))
       (set_tile "angl" (angtos angl))
       (mode_tile "angl" (- 1 (atoi a)))
       (mapcar '(lambda (x y) (mode_tile x (- 1 (atoi y))) (set_tile x (rtos (eval (read x)))))
               '("dist1" "dist2" "leng" "rad")
               (list d d a f)
       ) ;_  mapcar
       (action_tile "spos" "(setq spos $value)(spos_do)")
       (action_tile "dist1" "(setq dist1 (distof $value))(set_tile \"dist1\" (rtos (setvar \"chamfera\" dist1)))")
       (action_tile "dist2" "(setq dist2 (distof $value))(set_tile \"dist2\" (rtos (setvar \"chamferb\" dist2)))")
       (action_tile "leng" "(setq leng (distof $value))(set_tile \"leng\" (rtos (setvar \"chamferc\" leng)))")
       (action_tile "angl" "(setq angl (angtof $value))(set_tile \"angl\" (angtos (setvar \"chamferd\" angl)))")
       (action_tile "rad" "(setq rad (distof $value))(set_tile \"rad\" (rtos (setvar \"filletrad\" rad)))")
       (action_tile "mode" "(setq mode $value)(if(= mode \"tr\")(setq trim 1 tr \"1\" ntr \"0\")(setq trim 0 tr \"0\" ntr \"1\"))")
       (action_tile "tip" "(setq tip $value)(if(= tip \"l\")(setq l \"1\" pl \"0\")(setq l \"0\" pl \"1\"))")
       (action_tile "res" "(res_do)")
       (action_tile "gorep" "(setq dcl_xy (done_dialog 4))")
       (action_tile "go" "(setq dcl_xy (done_dialog 3))")

       (if (>= (setq what (start_dialog)) 3)
         (progn                         ;  
           (vla-startundomark (vla-get-activedocument (vlax-get-acad-object))) ;   undo
           ;;   
           (mapcar '(lambda (x y) (setvar x y)) vars (list 0 cham trim dist1 dist2 leng angl rad))
           (if (= f "1")
             (command "_.fillet")
             (command "_.chamfer")
           ) ;_  if
           (if (= tip "pl")
             (command "_p")
           ) ;_  if
           (while (= (getvar "cmdactive") 1) (command pause))
           (if (= what 4)
             (command "_delay" "600") ;_  
           ) ;_  if
           ;;   
           (vl-bb-set 'chamfill_ini (list dcl_xy mode tip spos cham trim dist1 dist2 leng angl rad))
           (foreach x vars (setvar x (eval (read x)))) ;  
           (vla-endundomark (vla-get-activedocument (vlax-get-acad-object))) ;   undo
         ) ;_  progn
       ) ;_  if
     ) ;_  while
     (unload_dialog dcl_id)
    )
  ) ;_  cond
  (princ)
) ;_  defun
